# CLMC monitoring specification for a basic scenario

## CONFIGURATION: SLICE
### Compute node configuration

#### Common context
| measurement | tag |
| --- | --- | --- |
| compute_node_config, | slice_id="SLICE1" | 

#### Specific context
| tag | tag |
| --- | --- |
| location='DC1', | comp_node_id='c1' |

#### Configurations
| field | field | field | timestamp |
| --- | --- | --- | --- |
| cpus=4, | memory=8, | storage=16 | 1515583926868000000 |

### Network configuration
__How do we describe network configuration ?__
__What is a format of an infrastructure slices ?__
__What is the relevant information ?__

#### Common context: network
| measurement | tag |
| --- | --- | --- |
| network_config,| slice_id='SLICE1' |

#### Specific context: network
| tag |
| --- | 
| network_id="NET1" |

#### Configurations: network
| field | timestamp |
| --- | --- | --- | --- | --- |
| bandwidth=400 | 1515583926868000000 |


#### Common context: Network interfaces
| measurement | tag |
| --- | --- | --- |
| network_interface_config,| slice_id='SLICE1' |

#### Specific context: Network interfaces
| tag | tag |
| --- | --- |
| comp_node_id='c1', | port_id='enps03', |

#### Configurations: Network interfaces
| field | field | timestamp |
| --- | --- | --- | --- |
| rx_constraint=1000, | tx_constraint=1000 | 1515583926868000000 |


## CONFIGURATION: SFC template (TOSCA)
### Media Service SFC states
__What are the SFC states ?__


### CONFIGURATION: Media Service SF states
__What are the SF states ?__


### CONFIGURATION: Media Service SF Instance states
#### Common context
| measurement | tag | tag | tag | tag | tag |
| --- | --- | --- | --- | --- | --- |
| sf_instance_surrogate_config, | location='DC1', | sfc='Scenario1_Template', | sfc_i='Scenario1_Instance_I1', | sf='MS_STREAMING', | sf_i='MS_STREAMING_1' | 

#### Specific context
| tag | 
| --- |
| surrogate_id='MS_STREAM_1_SURROGATE_1' | 

#### Configurations
| field | field | field | field | timestamp |
| --- | --- | --- | --- | --- |
| state='placed', | cpus=2, | memory=4, | storage=8 | 1515583926868000000 |

### CONFIGURATION: Media Service Function Instance Surrogates
#### Common context
| measurement | tag | tag | tag | tag | tag |
| --- | --- | --- | --- | --- | --- | --- |
| \<measurement label> | location='DC1', | sfc='Scenario1_Template', | sfc_i='Scenario1_Instance_I1', | sf='MS_STREAMING', | sf_i='MS_STREAMING_1', | 

#### Specific context
| tag |
| --- |
| surrogate_id='MS_STREAM_1_SURROGATE_1' | 

#### Configurations

__QUESTION__: Do we only allow a 1-to-1 mapping between Media Service SF Instances and Surrogates w.r.t. configurations (i.e: I asked for 2 CPUs, I got 2 CPUs). If yes, we could cut some of the fields below.

| field | field | field | field | timestamp |
| --- | --- | --- | --- | --- |
| state='booted', | cpus=2, | memory=4, | storage=8 | 1515583926868000000 |


## MONITORING
#### Common context: Usage and Performance
All of the specific context measurements below carry the following common context (this has not be replicated for brevity) for both usage and performance measurements. In this example, we illustrate using two surrogate VMs.

#TODO: Label as averages

| measurement | tag | tag | tag | tag | tag | tag | tag |
| --- | --- | --- | --- | --- | --- | --- | --- | --- |
| \<measurement>, | location='DC1', | comp_node_id='c1', | sfc='Scenario1_Template', | sfc_i='Scenario1_Instance_I1', | sf='MS_STREAMING', | sf_i='MS_STREAMING_1', |  surrogate_id ='MS_STREAM_1_SURROGATE_1' |
| \<measurement>, | location='DC2', | comp_node_id='c2', | sfc='Scenario1_Template', | sfc_i='Scenario1_Instance_I1', | sf='MS_STREAMING', | sf_i='MS_STREAMING_1', |  surrogate_id ='MS_STREAM_1_SURROGATE_2' |

Also NOTE: the metrics provided in the measurements below are effectively a 'snapshot' of usage over a relatively small period of time. The length of this snapshot may vary, depending on the underlying implementation of the instrumentation, so we might have to assume this snapshot is essentially an average of a period of 1 second. Measuring 'usage' is dependent on the units, for example as a proportion of a resource or as a proportion of time.

### Monitoring values: Monitor Service Function Instance Surrogate (VMs)
#### Monitoring values: CPU (Telegraf system metrics)
| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- |
| cpu | \<common tags> | cpu_time_user=40, | cpu_time_idle=5 | 1515583926868000000 |

#### Monitoring values: RAM (Telegraf system metrics)
| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- | --- |
| mem | \<common tags> | free=880, | total=2048, | 1515583926868000000 |

#### Monitoring values: Storage (Telegraf system metrics)
| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- | --- | --- |
| vm_host_storage_usage | \<common tags> | disk_free=8144, | swap_size=1576, read_bytes=4194304, | write_bytes=2097152 | 1515583926868000000 |

#### Monitoring values: Network (FLIPS network metrics)
__ Can we measure network usage for a specific VM from FLIPS monitoring? __

| measurement | \<common tags> | field | field | timestamp |
| --- | --- | --- | --- | --- | --- |
| vm_host_network_usage | \<common tags> | rx_bytes_port_M=5242880, | tx_bytes_port_M=15728640 | packets_dropped=198, | packets_error=5 | 1515583926868000000 |

#### Monitoring values: Surrogates

QUESTIONS
1. Is the content navigation tag and fully qualified domain name (SDN based)? [Most likely: yes]

| measurement | \<common tags> | tag | timestamp |
| --- | --- | --- | --- | --- | --- | --- |
| mpegdash_service_mon | \<common tags> | cont_nav='http://netflix.com/scream' | cont_rep='h264' | req_rate=10, | 'avg_resp_time=40, | peak_resp_time=230, | avg_error_rate=0.2, | avg_throughput=200, | \<userProfileField>=\<value> | quality_delivered='5', startup_delay='1200', dropped_segments='2', 1515583926868000000 |

| surrogate_route_mon | ... | location='DC1', cont_nav='http://netflix.com/scream', http_requests_fqdn_rate=386, avg_network_fqdn_latency=50,  |

